#include <pic16f88.h>
#include <sdcc-lib.h>
#include <stdint.h>
#include "lcd.h"
#include "delay.h"

typedef unsigned int word;
word at _CONFIG1 CONFIG1 = _WDT_OFF & _PWRTE_ON & _INTRC_IO & _MCLR_ON & _BODEN_OFF & _LVP_OFF & _CPD_OFF & _WRT_PROTECT_OFF & _DEBUG_OFF & _CCP1_RB3 & _CP_OFF;
word at _CONFIG2 CONFIG2 = _FCMEN_OFF & _IESO_OFF;


int main() {
	uint8_t digit;
	uint16_t result, div;

	PORTA = 0x00;
	PORTB = 0x00;
	
	ANSEL = 0x04;	//RA2 = A/D
	TRISA = 0x3E;	//RA7:6,0 outputs
	TRISB = 0X00;	//outputs

	OSCCON = 0x60;	//4MHz

	ADCON1 |= 0x80;	//right justified
	ADCON0 = 0xD1;	//turn AD module on

	lcd_init();

	lcd_write_op('R');
	lcd_write_op('e');
	lcd_write_op('a');
	lcd_write_op('d');
	lcd_write_op('y');

loop:
	while (!RA3);
	while (RA3) {
		if (RA1)
			RA0 = 0;
		else
			RA0 = 1;
	}
	while (!RA3);
	lcd_control_op(0x01);	//clear
	TMR1H = 0;
	TMR1L = 0;

wait_signal:
	ADCON0 |= 0x04;
	while (NOT_DONE);
	if (ADRESL < 100)
		goto wait_signal;

	T1CON |= 0x01;	//start timer 1

	while (RA1);
	T1CON &= 0xfe;	//stop timer 1

	result = (TMR1H << 8) | TMR1L;
	
	for (div=10000; div>0; div=div/10) {
		digit = result / div;
		lcd_write_op('0' + digit);
		result -= digit*div;
	}

	lcd_write_op('u');
	lcd_write_op('s');

	goto loop;
}
